/**
 *main的事件
 */
var mc = {
	LOADING_STATUS : 1, //加载状态 1可以加载2 不可以加载
	PAGE : 1, //当前的页数
	DATA_TYPE : 0, //0分类数据1收藏数据
	WHERE : 0//数据筛选条件 0代表全部分类数据 4收藏
};
/**
 *刷新条件
 */
function reload_where(data_type, where) {
	//切换分类
	if ((data_type !== mc.DATA_TYPE) || (where !== mc.WHERE)) {
		mc.LOADING_STATUS = 1;
		if (data_type == 0) {
			mc.WHERE = where;
		} else {
			//刷新收藏数据
			var db = api.require('db');
			db.openDatabase({
				name : 'yuezhe'
			}, function(ret, err) {
				if (ret.status) {
					//将记录插入数据库
					db.selectSql({
						name : 'yuezhe',
						sql : 'SELECT * FROM favorite;'
					}, function(ret, err) {
						if (ret.status) {
							//请求服务器
							var data = ret.data;
							var ids = '';
							for (var i = 0; i < data.length; i++) {
								ids += data[i]['ArticleId'] + ',';
							}
							mc.WHERE = ids;
						} else {
							mc.LOADING_STATUS = 0;
							mc.WHERE = 0;
						}
					});
				}
			});
		}
		mc.DATA_TYPE = data_type;
		var loadMore = $api.byId('load-more');
		var container = $api.byId('container');
		$api.removeCls(loadMore, 'hidden');
		$api.addCls(container, 'hidden');
		//开始重载
		setTimeout(function() {
			reload();
		}, 1000);
	}
	return true;
}

function dump(data) {
	var urlJson = JSON.stringify(data);
	api.alert({
		msg : urlJson
	});
}

/**
 *底部加载更多
 */
function bottomUpload() {
	api.addEventListener({
		name : 'scrolltobottom',
		extra : {
			threshold : 0 //设置距离底部多少距离时触发，默认值为0，数字类型
		}
	}, function(ret, err) {

		var bottom = $api.byId('bottom');
		if (bottom.innerHTML != "没有更多数据") {
			bottom.innerHTML = "<img src='../image/loading-bottom.gif' style='height:60%;width:auto;' />";

			api.ajax({
				url : 'http://yuezhe.duapp.com/index.php/Service/Service/getArticles',
				method : 'post',
				timeout : 30,
				dataType : 'json',
				returnAll : false,
				data : {
					values : {
						page : mc.PAGE,
						type : mc.DATA_TYPE,
						where : mc.WHERE
					}
				}
			}, function(ret, err) {
				if (ret) {
					//成功
					if (ret.success == '200') {
						addArticle(ret.data.articles, false);
						var bottom = $api.byId('bottom');
						bottom.innerHTML = "加载更多";
						mc.PAGE++;
						mc.LOADING_STATUS = 1;
					} else if (ret.success == '0000') {
						var bottom = $api.byId('bottom');
						bottom.innerHTML = "没有更多数据";
						mc.LOADING_STATUS = 0;
					}
				} else {
					api.toast({
						msg : err.msg,
						location : 'middle'
					});
				}
			});

		}
	});
}

/**
 *下拉刷新
 */
function topFlush() {
	api.setRefreshHeaderInfo({
		visible : true,
		loadingImg : 'widget://image/refresh.png',
		bgColor : '#ccc',
		textColor : '#fff',
		textDown : '下拉刷新...',
		textUp : '松开刷新...',
		showTime : true
	}, function(ret, err) {
		if (mc.LOADING_STATUS == 1) {
			if (mc.DATA_TYPE == 1) {
				if (reload_where(1, -1)) {
					api.ajax({
						url : 'http://yuezhe.duapp.com/index.php/Service/Service/getArticles',
						method : 'post',
						timeout : 30,
						dataType : 'json',
						returnAll : false,
						data : {
							values : {
								page : 1,
								type : mc.DATA_TYPE,
								where : mc.WHERE
							}
						}
					}, function(ret, err) {
						if (ret) {
							//成功
							if (ret.data.success == '200') {
								addArticle(ret.data.articles, true);
								mc.LOADING_STATUS = 1;
								mc.PAGE = 2;
							} else if (ret.data.success == '0000') {
								var bottom = $api.byId('bottom');
								bottom.innerHTML = "没有更多数据";
								mc.LOADING_STATUS = 0;
								var bottomS = $api.byId('main');
								bottomS.innerHTML = "";
							}
						} else {
							api.toast({
								msg : err.msg,
								location : 'middle'
							});
						}
						api.refreshHeaderLoadDone();
					});
				}
			} else {
				api.ajax({
					url : 'http://yuezhe.duapp.com/index.php/Service/Service/getArticles',
					method : 'post',
					timeout : 30,
					dataType : 'json',
					returnAll : false,
					data : {
						values : {
							page : 1,
							type : mc.DATA_TYPE,
							where : mc.WHERE
						}
					}
				}, function(ret, err) {
					if (ret) {
						//成功
						if (ret.data.success == '200') {
							addArticle(ret.data.articles, true);
							mc.LOADING_STATUS = 1;
							mc.PAGE = 2;
						} else if (ret.data.success == '0000') {
							var bottom = $api.byId('bottom');
							bottom.innerHTML = "没有更多数据";
							mc.LOADING_STATUS = 0;
							var bottomS = $api.byId('main');
							bottomS.innerHTML = "";
						}
					} else {
						api.toast({
							msg : err.msg,
							location : 'middle'
						});
					}
					api.refreshHeaderLoadDone();
				});
			}
		} else {
			api.refreshHeaderLoadDone();
		}
	});
}

function reload() {
	if (mc.LOADING_STATUS == 1) {
		mc.LOADING_STATUS = 0;
		api.ajax({
			url : 'http://yuezhe.duapp.com/index.php/Service/Service/getArticles',
			method : 'post',
			timeout : 30,
			dataType : 'json',
			returnAll : false,
			data : {
				values : {
					page : 1,
					type : mc.DATA_TYPE,
					where : mc.WHERE
				}
			}
		}, function(ret, err) {
			if (ret) {
				if (ret.success == '200') {
					addArticle(ret.data.articles, true);
					var loadMore = $api.byId('load-more');
					var container = $api.byId('container');
					$api.addCls(loadMore, 'hidden');
					$api.removeCls(container, 'hidden');
					mc.LOADING_STATUS = 1;
					mc.PAGE = 2
				} else if (ret.success == '0000') {
					var loadMore = $api.byId('load-more');
					var container = $api.byId('container');
					$api.addCls(loadMore, 'hidden');
					$api.removeCls(container, 'hidden');
					var bottom = $api.byId('bottom');
					bottom.innerHTML = "没有更多数据";
					var main = $api.byId('main');
					main.innerHTML = '';
					mc.LOADING_STATUS = 0;
				}
			} else {
				api.toast({
					msg : err.msg,
					location : 'middle'
				});
			}
		});
	}
}

//加载一页
function addArticle(articles, isReload) {
	var articleDoms = '';
	for ( i = 0; i < articles.length; i++) {
		var article = articles[i];
		var articleDom = createArticleDom(article);
		articleDoms = articleDoms + articleDom;
	}
	var main = $api.byId('main');
	if (isReload) {
		main.innerHTML = '';
	}
	$api.append(main, articleDoms);
}

//拼接一个dom
function createArticleDom(article) {
	var articleStr = '<div class="row" onclick="openOne(' + article.ArticleId + ');">';
	articleStr = articleStr + '<div class="col-24 text-center item-title">';
	articleStr = articleStr + '<p class="title">';
	articleStr = articleStr + article.Title;
	articleStr = articleStr + '</p>';
	articleStr = articleStr + '<p class="author">';
	articleStr = articleStr + '<span class="date">────</span>&nbsp;&nbsp;by&nbsp;&nbsp;' + article.Author + '&nbsp;&nbsp;<span class="date">────</span>';
	articleStr = articleStr + '</p>';
	articleStr = articleStr + '</div>';
	articleStr = articleStr + '<div class="col-24">';
	articleStr = articleStr + '<img class="item-img" src="' + article.Cover + '"/>';
	articleStr = articleStr + '</div>';
	articleStr = articleStr + '<div class="col-24 item-info">';
	articleStr = articleStr + '<p class="view text-left">';
	articleStr = articleStr + '<img src="../image/readNum.png" />&nbsp;' + article.ViewNum + '&nbsp;&nbsp;&nbsp;&nbsp;<img src="../image/psd.png" />&nbsp;<span class="item-favorite">' + article.FavoriteNum + '</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + article.UpTime;
	articleStr = articleStr + '</p>';
	articleStr = articleStr + '<div class="desc">';
	articleStr = articleStr + '<p class="desc-text">';
	articleStr = articleStr + article.Intro;
	articleStr = articleStr + '</p>';
	articleStr = articleStr + '</div></div></div><hr class="border-top-solid"/>';
	return articleStr;
}

//打开详情
function openOne(articleId) {
	api.openWin({
		name : 'item',
		url : './item.html',
		bounces : true,
		rect : {
			x : 0,
			y : 0,
			w : 'auto',
			h : api.winHeight
		},
		pageParam : {
			articleId : articleId
		}
	});
}